"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const express_1 = __importDefault(require("express"));
const mills_1 = require("./src/mills");
const customers_1 = require("./src/customers");
const configure_1 = require("./src/configure");
const app = (0, express_1.default)();
app.get("/customers", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    if (req.query.filter) {
        try {
            let obj = {
                filter: req.query.filter,
                isBlocked: req.query.isBlocked,
                limit: req.query.limit,
            };
            let tmp;
            tmp = yield customers_1.Customers.get(obj);
            res.send(tmp.data);
        }
        catch (err) {
            console.error(err);
            res.send("something went wrong");
        }
    }
    else {
        try {
            let tmp;
            tmp = yield customers_1.Customers.get({});
            res.send(tmp.data);
            return;
        }
        catch (err) {
            console.error(err);
            res.send("Something went wrong");
        }
    }
}));
app.get("/customers/:id", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    let obj = {
        id: req.params.id
    };
    let tmp;
    tmp = yield customers_1.Customers.get(obj);
    res.send(tmp.data);
}));
app.get("/mills/:id", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    let obj = {
        id: req.params.id
    };
    let tmp;
    tmp = yield mills_1.Mills.get(obj);
    res.send(tmp.data);
}));
app.get("/mills/filter/:filter", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    let obj = {
        filter: req.params.filter
    };
    let tmp;
    tmp = yield mills_1.Mills.get(obj);
    res.send(tmp.data);
}));
app.get("/users/:user/responsible/customers", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    let obj = {
        user: req.params.user
    };
    let tmp;
    tmp = yield customers_1.Customers.get(obj);
    res.send(tmp.data);
}));
app.get("/users/:user/followed/mills", (req, res) => __awaiter(void 0, void 0, void 0, function* () {
    let tmp;
    tmp = yield customers_1.Customers.get({ user: req.params.user });
    res.send(tmp.data);
}));
app.listen(5000, () => {
    console.log(`Listening on port 5000...`);
    configure_1.Configure.add("https://partnernet.andritz.com/sasapi/tst", "zlmxsuZtZT1dz_MSQJfAdQ..", "mQjGb-kLaSciXbdUFU-6fg..");
});
