import express, { Express, Request, Response } from 'express';
import dotenv from 'dotenv';
import { Mills } from "./src/mills";
import { Customers } from "./src/customers"
import { Configure } from "./src/configure";

const app: Express = express();

app.get("/customers", async (req: Request, res: Response) => {
if (req.query.filter) {
    try {
      let obj = {
        filter: req.query.filter,
        isBlocked: req.query.isBlocked,
        limit: req.query.limit,
      };
      let tmp: any;
      tmp = await Customers.get(obj);
      res.send(tmp.data);
    } catch (err) {
      console.error(err);
      res.send("something went wrong");
    }
  } else {
    try {
      let tmp: any;
      tmp = await Customers.get({});
      res.send(tmp.data);
      return;
    } catch (err) {
      console.error(err);
      res.send("Something went wrong");
    }
  }
});

app.get("/customers/:id", async (req: Request, res: Response) => {
  let obj = {
    id: req.params.id
  }
  let tmp: any;
  tmp = await Customers.get(obj);
  res.send(tmp.data);
});

app.get("/mills/:id", async (req, res) => {
  let obj = {
    id: req.params.id
  }
  let tmp: any;
  tmp = await Mills.get(obj);
  res.send(tmp.data);
});

app.get("/mills/filter/:filter", async (req: Request, res: Response) => {
  let obj = {
    filter: req.params.filter
  }
  let tmp: any;
  tmp = await Mills.get(obj);
  res.send(tmp.data);
});

app.get("/users/:user/responsible/customers", async (req: Request, res: Response) => {
  let obj = {
    user: req.params.user
  }
  let tmp: any;
  tmp = await Customers.get(obj);
  res.send(tmp.data);
});

app.get("/users/:user/followed/mills", async (req: Request, res: Response) => {
  let tmp: any;
  tmp = await Customers.get({ user: req.params.user });
  res.send(tmp.data);
});

app.listen(5000, () => {
  console.log(`Listening on port 5000...`);
  Configure.add(
    "https://partnernet.andritz.com/sasapi/tst",
    "zlmxsuZtZT1dz_MSQJfAdQ..",
    "mQjGb-kLaSciXbdUFU-6fg.."
  );
});
