"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Auth = void 0;
const axios_1 = __importDefault(require("axios"));
require("dotenv").config();
const https_1 = __importDefault(require("https"));
const configure_1 = require("./configure");
class Auth {
    constructor(token_value, generation_time, expires_in) {
        this.token_value = token_value;
        this.generation_time = generation_time;
        this.expires_in = expires_in;
    }
}
exports.Auth = Auth;
_a = Auth;
Auth.getTokenValue = () => __awaiter(void 0, void 0, void 0, function* () {
    yield _a.checkToken();
    return _a.token_value;
});
Auth.checkToken = () => __awaiter(void 0, void 0, void 0, function* () {
    let current_time = new Date();
    if (_a.token_value != undefined && _a.token_value != null) {
        let elapsed_time = Math.round((current_time.getTime() - _a.generation_time.getTime()) / 1000);
        if (elapsed_time >= _a.expires_in) {
            yield _a.getToken();
        }
        return;
    }
    else {
        yield _a.getToken();
    }
});
Auth.getToken = () => __awaiter(void 0, void 0, void 0, function* () {
    try {
        let token = yield axios_1.default.post(`${configure_1.Configure.base_ulr}/oauth/token`, {}, {
            httpsAgent: new https_1.default.Agent({ rejectUnauthorized: false }),
            auth: {
                username: configure_1.Configure.username,
                password: configure_1.Configure.password,
            },
            headers: {
                "Content-Type": "application/x-www-form-urlencoded",
                Connection: "keep-alive",
            },
            params: {
                grant_type: "client_credentials",
            },
        });
        _a.token_value = `Bearer ${token.data.access_token}`;
        _a.generation_time = new Date();
        _a.expires_in = token.data.expires_in;
    }
    catch (err) {
        console.error(err);
    }
});
