import { default as axios } from "axios";
require("dotenv").config();
import https from "https";
import { Configure } from "./configure";

export class Auth {
  token_value: any;
  generation_time: any;
  expires_in: any;
  static token_value: any;
  static generation_time: any;
  static expires_in: number;
  constructor(token_value: any, generation_time: any, expires_in: any) {
    this.token_value = token_value;
    this.generation_time = generation_time;
    this.expires_in = expires_in;
  }

  static getTokenValue = async () => {
    await this.checkToken();
    return this.token_value;
  };

  static checkToken = async () => {
    let current_time = new Date();
    if (this.token_value != undefined && this.token_value != null) {
      let elapsed_time = Math.round(
        (current_time.getTime() - this.generation_time.getTime()) / 1000
      );
      if (elapsed_time >= this.expires_in) {
        await this.getToken();
      }
      return;
    } else {
      await this.getToken();
    }
  };

  static getToken = async () => {
    try {
      let token = await axios.post(
        `${Configure.base_ulr}/oauth/token`,
        {},
        {
          httpsAgent: new https.Agent({ rejectUnauthorized: false }),
          auth: {
            username: Configure.username,
            password: Configure.password,
          },
          headers: {
            "Content-Type": "application/x-www-form-urlencoded",
            Connection: "keep-alive",
          },
          params: {
            grant_type: "client_credentials",
          },
        }
      );

      this.token_value = `Bearer ${token.data.access_token}`;
      this.generation_time = new Date();
      this.expires_in = token.data.expires_in;
    } catch (err) {
      console.error(err);
    }
  };
}
