"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Customers = void 0;
const axios_1 = __importDefault(require("axios"));
require("dotenv").config();
const auth_1 = require("./auth");
const configure_1 = require("./configure");
class Customers {
}
exports.Customers = Customers;
_a = Customers;
Customers.get = (obj) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        if (obj != undefined && obj != null) {
            let auth_token = yield auth_1.Auth.getTokenValue();
            let req_url;
            switch (true) {
                case Object.keys(obj).length === 0:
                    req_url = `${configure_1.Configure.base_ulr}/crm/v2/customers`;
                    break;
                case "id" in obj:
                    req_url = `${configure_1.Configure.base_ulr}/crm/v2/customers/${obj.id}`;
                    break;
                case ["filter", "isBlocked", "limit"].every((key) => Object.keys(obj).includes(key)):
                    const encoded_filter = encodeURI(obj.filter);
                    req_url = `${configure_1.Configure.base_ulr}/crm/v2/customers?filter=${encoded_filter}&isBlocked=${obj.isBlocked}&limit=${obj.limit}`;
                    break;
                case "user" in obj:
                    const encoded_user = encodeURI(obj.user);
                    req_url = `${configure_1.Configure.base_ulr}/crm/v2/users/${encoded_user}/responsible/customers`;
                    break;
            }
            let customers = yield axios_1.default.get(req_url, {
                headers: {
                    Authorization: auth_token,
                },
            });
            return customers;
        }
    }
    catch (err) {
        console.error(err);
    }
});
