import { default as axios } from "axios";
require("dotenv").config();
import { Auth } from "./auth";
import { Configure } from "./configure";

export class Customers {
  static get = async (obj: { id?: any; filter?: any; isBlocked?: any; limit?: any; user?: any; } | null | undefined) => {
    try {
      if (obj != undefined && obj != null) {
        let auth_token = await Auth.getTokenValue();
        let req_url: any;
        switch (true) {
          case Object.keys(obj).length === 0:
            req_url = `${Configure.base_ulr}/crm/v2/customers`;
            break;
          case "id" in obj:
            req_url = `${Configure.base_ulr}/crm/v2/customers/${obj.id}`;
            break;
          case ["filter", "isBlocked", "limit"].every((key) =>
            Object.keys(obj).includes(key)
          ):
            const encoded_filter = encodeURI(obj.filter);
            req_url = `${Configure.base_ulr}/crm/v2/customers?filter=${encoded_filter}&isBlocked=${obj.isBlocked}&limit=${obj.limit}`;
            break;
          case "user" in obj:
            const encoded_user = encodeURI(obj.user);
            req_url = `${Configure.base_ulr}/crm/v2/users/${encoded_user}/responsible/customers`;
            break;
        }

        let customers = await axios.get(req_url, {
          headers: {
            Authorization: auth_token,
          },
        });
        return customers;
      }
    } catch (err) {
      console.error(err);
    }
  };
}
