"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
exports.Mills = void 0;
const axios_1 = __importDefault(require("axios"));
require("dotenv").config();
const auth_1 = require("./auth");
const configure_1 = require("./configure");
class Mills {
}
exports.Mills = Mills;
_a = Mills;
Mills.get = (obj) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        if (obj != undefined && obj != null) {
            let auth_token = yield auth_1.Auth.getTokenValue();
            let req_url;
            switch (true) {
                case "id" in obj:
                    req_url = `${configure_1.Configure.base_ulr}/mpm/v2/mills/${obj.id}`;
                    break;
                case "filter" in obj:
                    const encoded_filter = encodeURI(obj.filter);
                    req_url = `${configure_1.Configure.base_ulr}/mpm/v2/mills?filter=${encoded_filter}`;
                    break;
                case "user" in obj:
                    const encoded_user = encodeURI(obj.user);
                    req_url = `${configure_1.Configure.base_ulr}/mpm/v2/users/${encoded_user}/followed/mills`;
                    break;
            }
            let mills = yield axios_1.default.get(req_url, {
                headers: {
                    Authorization: auth_token,
                },
            });
            return mills;
        }
    }
    catch (err) {
        console.error(err);
    }
});
