import { default as axios } from "axios";
require("dotenv").config();
import { Auth } from "./auth";
import { Configure } from "./configure";

export class Mills {
  static get = async (obj: { id?: any; filter?: any; user?: any; } | null | undefined) => {
    try {
      if (obj != undefined && obj != null) {
        let auth_token = await Auth.getTokenValue();
        let req_url: any;
        switch (true) {
          case "id" in obj:
            req_url = `${Configure.base_ulr}/mpm/v2/mills/${obj.id}`;
            break;
          case "filter" in obj:
            const encoded_filter = encodeURI(obj.filter);
            req_url = `${Configure.base_ulr}/mpm/v2/mills?filter=${encoded_filter}`;
            break;
          case "user" in obj:
            const encoded_user = encodeURI(obj.user);
            req_url = `${Configure.base_ulr}/mpm/v2/users/${encoded_user}/followed/mills`;
            break;
        }

        let mills = await axios.get(req_url, {
          headers: {
            Authorization: auth_token,
          },
        });
        return mills;
      }
    } catch (err) {
      console.error(err);
    }
  };
}
